local Me=CreateFrame("Frame","vZifnabsBufmon")
vZifnabs.mod.bufmon=Me
local mod=vZifnabs.mod
local L={}
local db=nil

local health={sound="Interface\\AddOns\\vZifnabs\\alarm.mp3",warnpercent=0,firstwarn=40}
local buff={}
local hands={}
local ignore_buff={	["INV_Misc_Bandage_"]="begin",
					["DeathScream"]="equal",
					["Spell_Holy_RemoveCurse"]="equal",
					["Spell_Fire_Fire"]="equal",
					["HarmUndeadAura"]="equal",
					["Spell_Shadow_UnholyFrenzy"]="equal",
				}

-- -----------------------------------------------------------------
-- INITIALIZE
-- -----------------------------------------------------------------
function Me:Initialize()
	db=vZifnabsDB
	if not db.bufmon then db.bufmon={hud=true} end
	L=vZifnabs.L
	
	mod.core:RegisterEvent("TICK","bufmon",Me.Tick)
	if UnitClass("player")=="Warlock" then ignore_buff["Spell_Shadow_SoulGem"]="equal" end
end

-- -----------------------------------------------------------------
-- CLOCK
-- -----------------------------------------------------------------
function Me:Tick(tick,ticktime)
	local dead=UnitIsDeadOrGhost("player")
	local healthpercent=math.floor(100*UnitHealth("player")/UnitHealthMax("player"))
	if healthpercent>=health.firstwarn or dead then health.warnpercent=health.firstwarn
	else
		if healthpercent<health.warnpercent then
			PlaySoundFile(health.sound,"Master")
			health.warnpercent=health.warnpercent-15
		end
		mod.hud:Write(mod.core:Repl(L.msg.lowhealth,"<percent>",healthpercent),nil,true)
	end
	
	for nr=0,19,1 do
		local texture=GetPlayerBuffTexture(nr)
		if texture==nil then break end
		local duration=GetPlayerBuffTimeLeft(nr)
		local endtime=ticktime+duration
		local parse=mod.core:Split(texture,"\\")
		local fullbuffname=parse[getn(parse)]
		parse=mod.core:Split(fullbuffname,"_")
		local buffname=parse[getn(parse)]
		local ignore=false
		for ignbuf,mode in pairs(ignore_buff) do
			if mode=="equal" and fullbuffname==ignbuf then ignore=true
			elseif mode=="contain" and string.find(fullbuffname,ignbuf) then ignore=true
			elseif mode=="begin" and string.find(fullbuffname,ignbuf)==1 then ignore=true
			end
			if ignore then break end
		end
		if not ignore then
			if buff[fullbuffname] and math.abs(buff[fullbuffname].endtime-endtime)>5 then buff[fullbuffname]=nil end
			if not buff[fullbuffname] then buff[fullbuffname]={texture=texture, short=buffname, duration=duration, start=ticktime} end
			buff[fullbuffname].endtime=endtime -- adjust ending time
			buff[fullbuffname].last=ticktime
			if buff[fullbuffname].duration>40 and duration<20 and not buff[fullbuffname].hud then
				buff[fullbuffname].hud=true
				if string.len(buffname)<3 then buffname=fullbuffname end
				local text=mod.core:Repl(L.msg.fadingbuff,"<buff>",L.buff[fullbuffname] or buffname)
				local chat=mod.core:Repl(L.msg.fadingbuff,"<buff>",L.buff[fullbuffname] or fullbuffname)
				mod.hud:Write(text,"RaidWarning",nil,chat)
			end
		end
	end	
	
	for fullbuffname,info in pairs(buff) do
		if info.last and info.last~=ticktime then buff[fullbuffname]=nil end
	end
	
	local mainbuff, mainlast, maincharges, offbuff, offlast, offcharges = GetWeaponEnchantInfo();
	if not mainbuff then buff.mainhand=nil
	elseif mainlast<20000 and (not buff.mainhand or not buff.mainhand.hud) then
		mod.hud:Write(mod.core:Repl(L.msg.fadingbuff,"<buff>",L.keyword.mainhand),"RaidWarning") 
		buff.mainhand={hud=true}
	end
	if not offbuff then buff.offhand=nil
	elseif offlast<20000 and (not buff.offhand or not buff.offhand.hud) then 
		mod.hud:Write(mod.core:Repl(L.msg.fadingbuff,"<buff>",L.keyword.offhand),"RaidWarning") 
		buff.offhand={hud=true}
	end
end

-- -----------------------------------------------------------------
-- Buff Target
-- -----------------------------------------------------------------
function Me:List()
	for nr=0,19,1 do 
		local texture=GetPlayerBuffTexture(nr)
		if texture then mod.core:Print(texture) end
	end
end
