local MyName="vZifnabsEmotor"
local Me=CreateFrame("Frame",MyName)
vZifnabs.mod.emotor=Me
local mod=vZifnabs.mod
local db={}
local L={}

local infight=false
local summoning={}
local startedspell=nil
local lastfishing=0
local lastemotor={}
local undeflist={}
local playername=UnitName("player")
local playerclass=UnitClass("player")

-- Slash Commands
SLASH_VZIFNABSEMOTOR1 = "/ze"
SlashCmdList["VZIFNABSEMOTOR"]=function (cmd) Me:SlashCommand(cmd) end

-- -----------------------------------------------------------------
-- INITIALIZE
-- -----------------------------------------------------------------
function Me:Initialize()
	db=vZifnabsDB
	L=vZifnabs.L
	if not db.emotor then db.emotor={petname={},list={},repl={},classify={}} end
	
	for list,data in pairs(L.emotor.list) do
		if not db.emotor.list[list] then db.emotor.list[list]=data end
	end
	
	if not db.emotor.repl then db.emotor.repl={} end -- kann dann auch wieder weg
	for key,list in pairs(L.emotor.repl) do
		if not db.emotor.repl[key] then db.emotor.repl[key]=list end
	end
	
	mod.core:RegisterEvent("ONUPDATE","emotor",Me.OnUpdate)
	mod.core:RegisterEvent("PLAYER_REGEN_DISABLED","emotor",Me.PLAYER_REGEN_DISABLED)
	mod.core:RegisterEvent("PLAYER_REGEN_ENABLED","emotor",Me.PLAYER_REGEN_ENABLED)
	mod.core:RegisterEvent("SPELLCAST_START","emotor",Me.SPELLCAST_START)
	mod.core:RegisterEvent("SPELLCAST_SUCCEEDED","emotor",Me.SPELLCAST_SUCCEEDED)
	mod.core:RegisterEvent("SPELLCAST_CHANNEL_START","emotor",Me.SPELLCAST_CHANNEL_START)
	mod.core:RegisterEvent("SPELLCAST_CHANNEL_STOP","emotor",Me.SPELLCAST_CHANNEL_STOP)
end

function Me:OnUpdate()
	if summoning.slot then
		local petname=UnitName("pet")
		if petname~=summoning.current and petname~="Unknown" then
			db.emotor.petname[summoning.slot]=petname 
			db.emotor.petname.current=petname
			summoning={}
		end
	end
end

-- -----------------------------------------------------------------
-- PLAYER REGEN EN/DISABLED
-- -----------------------------------------------------------------
function Me:PLAYER_REGEN_DISABLED() 
	infight=true 
end

function Me:PLAYER_REGEN_ENABLED() 
	infight=false 
end

-- -----------------------------------------------------------------
-- SPELLCAST START
-- -----------------------------------------------------------------
function Me:SPELLCAST_START(event,spell,number,more)
	summoning={}
	startedspell=spell
	local given_sublist=nil
	if spell==L.keyword.soulstone then 
		local sstarget=UnitName("player")
		if UnitInParty("target") or UnitInRaid("target") then sstarget=UnitName("target") end
		if sstarget==UnitName("player") then given_sublist="NOTARGET" end
		mod.core:Print(mod.core:Repl(L.msg.soulstoneset,"<target>",sstarget))
		local storetime=30*60 -- 29*60+30 -- sollten eigentlich 30min sein, real aber offenbar eher 29:30
		mod.scheduler:Remind(storetime-120,mod.core:Repl(L.msg.soulstonerest,{"<tgt>","<rest>"},{sstarget,"120"}))
		mod.scheduler:Remind(storetime-60,mod.core:Repl(L.msg.soulstonerest,{"<tgt>","<rest>"},{sstarget,"60"}))
		mod.scheduler:Remind(storetime-20,mod.core:Repl(L.msg.soulstonerest,{"<tgt>","<rest>"},{sstarget,"20"}))
		mod.scheduler:Remind(storetime,mod.core:Repl(L.msg.soulstoneout,"<tgt>",sstarget))
	end
	Me:emotor(spell,given_sublist)
end

-- -----------------------------------------------------------------
-- SPELLCAST SUCCESS
-- -----------------------------------------------------------------
function Me:SPELLCAST_SUCCEEDED(event,arg1)
	mod.core:Print("SPELL SUCCEEDED: "..(arg1 or "nil"))
end

-- -----------------------------------------------------------------
-- SPELLCAST CHANNEL START
-- -----------------------------------------------------------------
function Me:SPELLCAST_CHANNEL_START(event,duration,spell,rank)
	if spell==L.keyword.fishing then
		if lastfishing==0 or time()-lastfishing>120 then spell=spell.." Begin" end
		lastfishing=time()
	elseif playerclass=="WARLOCK" and duration==15000 then spell="Soul Drain" 
	end
	startedspell=spell
	Me:emotor(spell)
end

-- -----------------------------------------------------------------
-- SPELLCAST CHANNEL STOP
-- -----------------------------------------------------------------
function Me:SPELLCAST_CHANNEL_STOP(event,wtf,spell,rank)
--	mod.core:Print("SPELL CHANNEL STOP: "..(spell or startedspell or "nil"))
end

-- -----------------------------------------------------------------
-- SLASH COMMAND
-- -----------------------------------------------------------------
function Me:SlashCommand(cmd)
	local word=mod.core:Split(mod.core:Trim(string.lower(cmd))," ")
	if word[1]=="pet" then 
		Me:Pet(word[2])
	elseif word[1]=="reload" then
		for list,data in pairs(L.emotor.list) do
			db.emotor.list[list]=data 
		end
		db.emotor.repl=L.emotor.repl
		mod.core:Print("ok")
	elseif db.emotor.list[word[1]] then
		Me:emotor(word[1],word[2])
	else
		mod.core:Print(mod.core:Repl(L.msg.undefinedlist,"<list>",word[1] or "nil"))
	end
end

function Me:Pet(cmd)
	if cmd=="attack" then
		PetAttack()
		Me:emotor("Pet Attack")
	elseif cmd=="dismiss" then
		PetDismiss()
		Me:emotor("Pet Dismiss")
	elseif cmd=="stay" then
		PetWait()
		Me:emotor("Pet Stay")
	elseif cmd=="follow" then
		PetFollow()
		Me:emotor("Pet Follow")
	else
		mod.core:Print(mod.core:Repl(L.msg.undefparm,"<parm>",cmd or "nil"))
	end
end

-- -----------------------------------------------------------------
-- EMOTOR
-- -----------------------------------------------------------------
function Me:emotor(originallist,given_sublist)
	local list=originallist
	if db.emotor.list[originallist] and db.emotor.list[originallist].route then list=db.emotor.list[originallist].route end
	if not db.emotor.list[list] then
		if not undeflist[list] or time()-undeflist[list]>300 then
			mod.core:Print(mod.core:Color(mod.core:Repl(L.msg.undefinedlist,"<list>",list),"808080"))
			undeflist[list]=time()
		end
	else
		local px,py,zone,pos=mod.locator:GetLoc()
		local rand=math.random(100)
		local ratio=(db.emotor.list[list].ratio or 101)
		if not lastemotor[list] then lastemotor[list]={etime=0,px=0,py=0} end
		local last=time()-lastemotor[list].etime
		if lastemotor[list].etime>0 and last<40 and ratio~=101 then 
			ratio=math.max(0,math.floor(ratio-(1600-last*last)/40))
			if px==lastemotor[list].px and py==lastemotor[list].py and last<120 then 
				ratio=0 
			end
		end
		if rand<ratio then
			lastemotor[list]={etime=time(),px=px,py=py}
			local targetname=UnitName("target") or ""
			local petname=UnitName("pet") or ""
			if petname==L.keyword.unknown then petname=db.emotor.petname.current or "" end
			local cursorname=getglobal("GameTooltipTextLeft1"):GetText() or ""
			-- Strip unwanted prefixes and sufixes from target and cursor
			targetname=Me:Strip(targetname)
			cursorname=Me:Strip(cursorname)

			-- sublist wählen
			local sublist=given_sublist or "ALWAYS"
			if not db.emotor.list[list][sublist] then
				if not UnitExists("target") then sublist="NOTARGET"
				else
					sublist="TARGET"
					local target=UnitName("target")
					if db.emotor.list[list]["FRIEND"] and db.emotor.classify[target] then sublist=db.emotor.classify[target]
					end
					if sublist=="TARGET" and db.emotor.list[list]["FRIEND"] then
						if GetGuildInfo("target")==GetGuildInfo("player") then sublist="FRIEND"
						elseif UnitInParty("target") or UnitInRaid("target") then sublist="FRIEND"
						end
					end
					if sublist=="TARGET" and db.emotor.list[list]["ENEMY"] then
						if UnitCanAttack("player","target") then sublist="ENEMY" end
					end
				end
			end -- not sublist
			
			if list==L.keyword.redemption then
				if cursorname==L.keyword.redemption then cursorname=targetname end
			end
		
			-- entry wählen und aufbereiten
						
			local saylist=Me:selectEntries(db.emotor.list[list][sublist].text)
			local emolist=Me:selectEntries(db.emotor.list[list][sublist].emotes)
			local sizes=getn(saylist)
			local nrs=0
			if sizes>0 then nrs=math.random(sizes) end
			local sizee=getn(emolist)
			local nre=0
			if sizee>0 then nre=math.random(sizee) end
			local say=saylist[nrs]
			local emo=emolist[nre]
			if say and string.find(say,"&&") then 
				local split=mod.core:Split(say,"&&",2)
				say=split[1]
				emo=split[2]
			end
			if db.emotor.list[list].special then say,emo=Me:Special(originallist,say,emo) end
			
			local channel="SAY"
			local language=nil -- TODO language wählen
			if say and strlower(string.sub(say,1,3))=="/y " then
				say=mod.core:Trim(string.sub(say,3))
				channel="YELL"
			end
		
			if say then say=mod.core:Repl(say,{"<.>","<!>","<#>","<pet>"},{playername,targetname,cursorname,petname}) end
			if emo then emo=mod.core:Repl(emo,{"<.>","<!>","<#>","<pet>"},{playername,targetname,cursorname,petname}) end
			
			local playersex=UnitSex("player")
			local targetsex=UnitSex("target") or 1
			if targetsex==1 then targetsex=Me:GetSex(targetname) end
			local cursorsex=Me:GetSex(cursorname)
			for key,list in pairs(db.emotor.repl) do
				if say then say=mod.core:Repl(say,{"<."..key..">","<!"..key..">","<#"..key..">"},{list[playersex],list[targetsex],list[cursorsex]}) end
				if emo then emo=mod.core:Repl(emo,{"<."..key..">","<!"..key..">","<#"..key..">"},{list[playersex],list[targetsex],list[cursorsex]}) end
			end
			
			local race=UnitRace("target") or UnitCreatureFamily("target") or UnitClass("target") or "Whatever"
			if say then say=mod.core:Repl(say,{"<!race>"},{race}) end
			if emo then emo=mod.core:Repl(emo,{"<!race>"},{race}) end
		
			-- Ausgabe von emote und say
			if emo and emo~="" then
				if string.sub(emo,1,1)=="/" then DoEmote(string.sub(emo,2))	else SendChatMessage(emo,"EMOTE") end
			end
			if say and say~="" then SendChatMessage(say,channel,(language or "Common")) end
		end -- rand>ratio
	end -- if emotor[list]
end

-- -----------------------------------------------------------------
-- SELECT ENTRIES
-- -----------------------------------------------------------------
function Me:selectEntries(list)
	local resultlist={}
	local rn=0
	for n=1,getn(list),1 do
		local use=nil
		if type(list[n])~="table" then use=list[n]
		elseif list[n][playername]~="X" then use=list[n].text
		end
		if use then
			rn=rn+1
			resultlist[rn]=use
		end
	end
	return resultlist
end

-- -----------------------------------------------------------------
-- SPECIAL
-- -----------------------------------------------------------------
function Me:Special(listname,say,emo)
	local word=mod.core:Split(listname," ")
	if word[1]==L.keyword.summon then
		local petname=db.emotor.petname[word[2]] or ""
		if petname=="Unknown" then petname="" end
		say=mod.core:Repl(say,"<pet>",petname)
		emo=mod.core:Repl(emo,"<pet>",petname)
		if petname=="" then summoning={slot=word[2],current=UnitName("pet")} end
	end
	return say,emo
end

-- -----------------------------------------------------------------
-- STRIP
-- -----------------------------------------------------------------
function Me:Strip(name)
	for n=1,getn(L.emotor.stripprefix),1 do	
		if string.find(name,L.emotor.stripprefix[n])==1 then name=string.sub(name,string.len(L.emotor.stripprefix[n])+1) end
	end
	return name
end

-- -----------------------------------------------------------------
-- GETSEX
-- -----------------------------------------------------------------
function Me:GetSex(name)
	local sex=1
	-- TODO search through sexlist for sex of "name"
	return sex
end